(*************************************************************************
 *                                                                       *
 *                    XII Olimpiada Informatyczna                        *
 *                                                                       *
 *   Rozwizanie zadania: BAN (Banknoty)                                 *
 *   Plik:                ban1.pas                                       *
 *   Autor:               Jakub Radoszewski                              *
 *   Opis:                Rozwizanie wzorcowe do zadania BAN (Banknoty) *
 *                        Jzyk: Pascal                                  *
 *                                                                       *
 *************************************************************************)

const MAX_N = 200;
const MAX_K = 20000;
const NIESKONCZONOSC = 1000000000;

{Element listy wskanikowej}
type pElement=^Element;
Element =
record
  w : LongInt; {warto}
  nast,pop : pElement; {wskaniki do poprzedniego i kolejnego elementu listy}
end;

var
  n,k,i : LongInt;
  b,c   : array[1..MAX_N] of LongInt;
  R     : array[0..MAX_K] of LongInt; {R[x] to minimalna liczba banknotw, w
                  jakiej mona wypaci kwot x przy pomocy dotychczas
                  rozwaonych nominaw}
  M     : array[0..MAX_K] of LongInt; {Tablica pomocniczna zdefiniowana poprzez
                   M[i]=R[r + i*b[nr]] - i dla tablicy R przed uaktualnieniem}
  wyn   : array[0..MAX_K,1..MAX_N] of LongInt; {Tablica wskazujca dla kadej
                                 kwoty i dla
                                 kadego banknotu, ile sztuk tego banknotu
                                 zostao uyte w optymalnym otrzymaniu kwoty}

{Odczyt danych}
procedure odczyt;
var i : LongInt;
begin
  ReadLn(n);
  for i := 1 to n do
    Read(b[i]);
  for i := 1 to n do
    Read(c[i]);
  Read(k);
end; {odczyt}

{Inicjalizacja tablic R i wyn}
procedure inicjuj;
var i,j : LongInt;
begin
  R[0] := 0;
  for i := 1 to k do
    R[i] := NIESKONCZONOSC;
  for i := 1 to k do
    for j := 1 to n do
      wyn[i][j] := 0;
end; {inicjuj}

{Aktualizuje tablic R, analizujc kolejny nomina banknotw (o numerze nr)}
procedure aktualizuj(nr : LongInt);
var x,i : LongInt;
head,tail,tmp : ^Element;
begin
  for x := 0 to b[nr] - 1 do {r-kolejna reszta modulo nomina b[nr]}
  begin
    head := nil;
    tail := nil;
    i := 0;
    while x + i*b[nr] <= k do
    begin
      if R[x + i*b[nr]] = NIESKONCZONOSC then
        M[i] := NIESKONCZONOSC
      else
        M[i] := R[x + i*b[nr]] - i;
      while (tail <> nil) and (M[tail^.w] >= M[i]) do
      begin
        {usunicie ostatniego elementu z kolejki}
        tmp := tail^.pop;
        Dispose(tail);
        tail := tmp;
        if tail = nil then
          head := nil
        else
          tail^.nast := nil;          
      end; {while}
      
      {woenie liczby i na koniec kolejki}
      New(tmp);
      tmp^.w := i;
      tmp^.nast  := nil;
      tmp^.pop   := tail;
      if tail <> nil then
        tail^.nast := tmp;
      tail := tmp;
      if head = nil then
        head := tail;
      
      R[x + i*b[nr]] := M[head^.w] + i;
      wyn[x + i*b[nr],nr] := i - head^.w;
      if head^.w = i - c[nr] then
      begin
        {usunicie pierwszego elementu z kolejki}
        tmp := head^.nast;
        Dispose(head);
        head := tmp;
        if head = nil then
          tail := nil
        else
          head^.pop := nil;
      end; {if}
      Inc(i);
    end; {while}
  end; {for}
end; {aktualizuj}

procedure pisz(n,k : LongInt);
begin
  if n>1 then
    pisz(n - 1,k - wyn[k,n]*b[n]);
  if n = 1 then
    Write(wyn[k][n])
  else
    Write(' ',wyn[k][n]);
end; {pisz}

begin
  odczyt;
  inicjuj;
  for i := 1 to n do
    aktualizuj(i);
  WriteLn(R[k]);
  pisz(n,k);
  WriteLn;
end. {program}
