/*************************************************************************
 *                                                                       *
 *                    XII Olimpiada Informatyczna                        *
 *                                                                       *
 *   Rozwizanie zadania: BAN (Banknoty)                                 *
 *   Plik:                ban.cpp                                        *
 *   Autor:               Jakub Radoszewski                              *
 *   Opis:                Rozwizanie nieoptymalne do zadania BAN        *
 *                        Jzyk: C++                                     *
 *                        (backtracking)                                 *
 *                                                                       *
 *************************************************************************/
#include<cstdio>
#include<algorithm>
using namespace std;

const int MAX_N = 200;
const int MAX_K = 20000;
const int NIESKONCZONOSC = 1000000000;

int n,k,wyn;
int b[MAX_N + 1],c[MAX_N + 1];
int tab[MAX_N + 1];
int t[MAX_N + 1];

//Odczyt danych
void odczyt()
{
  int i;
  scanf("%d",&n);
  for(i = 0;i < n;i++)
    scanf("%d",&b[i]);
  for(i = 0;i < n;i++)
    scanf("%d",&c[i]);
  scanf("%d",&k);
} //odczyt

/* Rekurencyjny backtracking; analizuje banknoty w kolejnoci malejcych
 * nominaw, kadego banknotu bierze dowoln dozwolon liczb sztuk
 * i kontynuuje wyszukiwanie.*/
void oblicz(int nr,int kw,int akt) //parametry: numer banknotu, kwota do
                                   //wypacenia i liczba ju zuytych banknotw
{
  if (akt >= wyn) //nie osigniemy w ten sposb mniejszej liczby banknotw
    return;
  if (!kw) //uzyskalimy kwot, sprawdzamy, czy zuylimy mao banknotw
  {
    if (akt < wyn)
    {
      for(int i=0;i<n;i++)
        tab[i]=t[i];
      wyn=akt;
    }
  }
  else
  if (nr >= 0)
  {
    int s = min(c[nr],kw/b[nr]);
    for(int i = s;i >= 0;i--)
    {
      t[nr] = i;
      oblicz(nr - 1,kw - i*b[nr],akt + i);
    }
    t[nr] = 0;
  } //if
} //oblicz

int main()
{
  odczyt();
  wyn = NIESKONCZONOSC;
  for(int i = 0;i <= n;i++)
    t[i] = 0;
  oblicz(n - 1,k,0);
  printf("%d\n",wyn);
  for(int i = 0;i < n - 1;i++)
    printf("%d ",tab[i]);
  printf("%d\n",tab[n - 1]);
  return 0;
} //main
