(*************************************************************************
 *                                                                       *
 *                    XII Olimpiada Informatyczna                        *
 *                                                                       *
 *   Rozwizanie zadania: SZA (Szablon)                                  *
 *   Plik:                sza2.pas                                       *
 *   Autor:               Jakub Radoszewski                              *
 *   Opis:                Rozwiazanie nadoptymalne                       *
 *                        Program o zoonoci czasowej                  *
 *                        i pamiciowej O(n), obliczajcy dugoci       *
 *                        szablonw on-line.                             *
 *                                                                       *
 *************************************************************************)

const MAX_LEN = 500000;

(* Deklaracje zmiennych globalnych. *)
var
  pref_suf : array[0..MAX_LEN] of LongInt;
                             {Tablica dugoci najduszych prefikso-sufiksw}
                             {tak zwana funkcja prefiksowa).}
  sl : array[1..MAX_LEN] of Char; {Rozwaane sowo.}
  n : LongInt; {Dugo rozwaanego sowa.}
  j, b, q : LongInt; {Zmienne pomocnicze programu gwnego.}
  zakres : array[0..MAX_LEN] of LongInt;
                             {Zakresy sowa, ktre mona pokry poszczeglnymi}
                             {prefiksami sowa, jako szablonami.}
  szablony : array[0..MAX_LEN] of LongInt;
                             {Najkrtsze szablony dla kolejnych}
                             {prefiksw sowa.}

procedure odczyt;
var ch : Char;
begin
  n := 0;
  while not Eoln(input) do
  begin
    Read(ch);
    Inc(n);
    sl[n] := ch
  end {while}
end; {odczyt}

(* Procedura wyliczajca wartoci funkcji prefiksowej
 * dla podanego w parametrze sowa. *)
procedure licz_pref_suf;
var k, q : LongInt;
begin
  k := 0;
  (* Inicjalizacja funkcji prefiksowej. *)
  pref_suf[0] := 0;
  pref_suf[1] := 0;
  
  (* Wyliczanie kolejnych wartoci funkcji prefiksowej. *)
  for q := 2 to n do
  begin
    (* Niezmiennik: najduszy prefikso-sufiks prefiksu danego
    sowa o dugoci q ma dugo k. *)
    while (k > 0) and (sl[k + 1] <> sl[q]) do
      k := pref_suf[k];
    if sl[k + 1] = sl[q] then
      Inc(k);
    pref_suf[q] := k
  end {for}
end; {licz_pref_suf}


begin
  (* Odczyt sowa i wyliczenie funkcji prefiksowej. *)
  odczyt;
  licz_pref_suf;

  (* Obliczanie najkrtszych szablonw dla prefiksw sowa,
  wykonywane on-line. *)
  for j := 1 to n do
  begin
    szablony[j] := j;
    zakres[j] := j
  end; {for}
  
  (* Ptla po wszystkich, duszych ni jeden, prefiksach
  danego sowa - w j-tym kroku rozwaamy j-ty prefiks. *)
  for j := 2 to n do
  begin
    b := pref_suf[j];
    if b > 0 then
    begin
      (* Sprawdzamy, czy szablon najduszego prefikso-sufiksu
      danego prefiksu sowa jest dobrym szablonem dla aktualnego
      prefiksu: *)
      q := szablony[b];
      if zakres[q] >= j - q then
      begin
        (* jeeli tak, to wybieramy jego jako szablon, *)
        szablony[j] := q;
        zakres[q] := j
      end {if}
      (* jeeli nie, to ju jest ustawione szablony[i]=i. *)
    end {if}
  end; {for}
  
  (* Wypisanie wyniku *)
  WriteLn(szablony[n])
end. {program}
